aboutsummaryrefslogtreecommitdiffstats
path: root/mcp/scripts/lib.sh
diff options
context:
space:
mode:
authorAlexandru Avadanii <Alexandru.Avadanii@enea.com>2017-09-08 23:03:56 +0200
committerAlexandru Avadanii <Alexandru.Avadanii@enea.com>2017-10-14 01:14:54 +0000
commitea64dc22ea171d45ae60aff682fcadf9d525889b (patch)
tree4e098d0370f8b6fb43b4ecda31af6ce4642ef98f /mcp/scripts/lib.sh
parent139aacf390d38b60f4fe4fd618a0bcf6b54b35cf (diff)
states: Split virtual_control_plane from maas
We should eventually also support baremetal deploys without a virtualized control plane (VCP), so decouple MaaS provisioning from VCP provisioning. While at it, move "wait_for" bash function from maas state to common library file, lib.sh. Change-Id: I32c33135655cb6aceae901a5f92b51265a8c84b4 Signed-off-by: Alexandru Avadanii <Alexandru.Avadanii@enea.com> (cherry picked from commit ebd7067904b36ae32566da63e433365948a1f973)
Diffstat (limited to 'mcp/scripts/lib.sh')
-rw-r--r--mcp/scripts/lib.sh33
1 files changed, 23 insertions, 10 deletions
diff --git a/mcp/scripts/lib.sh b/mcp/scripts/lib.sh
index fcc5d76ac..748c6dde1 100644
--- a/mcp/scripts/lib.sh
+++ b/mcp/scripts/lib.sh
@@ -3,7 +3,7 @@
# Library of shell functions
#
-generate_ssh_key() {
+function generate_ssh_key {
# shellcheck disable=SC2155
local mcp_ssh_key=$(basename "${SSH_KEY}")
local user=${USER}
@@ -20,7 +20,7 @@ generate_ssh_key() {
sudo install -D -o "${user}" -m 0600 "${mcp_ssh_key}" "${SSH_KEY}"
}
-get_base_image() {
+function get_base_image {
local base_image=$1
local image_dir=$2
@@ -28,7 +28,7 @@ get_base_image() {
wget -P "${image_dir}" -N "${base_image}"
}
-cleanup_vms() {
+function cleanup_vms {
# clean up existing nodes
for node in $(virsh list --name | grep -P '\w{3}\d{2}'); do
virsh destroy "${node}"
@@ -40,7 +40,7 @@ cleanup_vms() {
done
}
-prepare_vms() {
+function prepare_vms {
local -n vnodes=$1
local base_image=$2
local image_dir=$3
@@ -60,7 +60,7 @@ prepare_vms() {
done
}
-create_networks() {
+function create_networks {
local -n vnode_networks=$1
# create required networks, including constant "mcpcontrol"
# FIXME(alav): since we renamed "pxe" to "mcpcontrol", we need to make sure
@@ -80,7 +80,7 @@ create_networks() {
done
}
-create_vms() {
+function create_vms {
local -n vnodes=$1
local -n vnodes_ram=$2
local -n vnodes_vcpus=$3
@@ -119,7 +119,7 @@ create_vms() {
done
}
-update_mcpcontrol_network() {
+function update_mcpcontrol_network {
# set static ip address for salt master node, MaaS node
# shellcheck disable=SC2155
local cmac=$(virsh domiflist cfg01 2>&1| awk '/mcpcontrol/ {print $5; exit}')
@@ -131,7 +131,7 @@ update_mcpcontrol_network() {
"<host mac='${amac}' name='mas01' ip='${MAAS_IP}'/>" --live
}
-start_vms() {
+function start_vms {
local -n vnodes=$1
# start vms
@@ -141,7 +141,7 @@ start_vms() {
done
}
-check_connection() {
+function check_connection {
local total_attempts=60
local sleep_time=5
local attempt=1
@@ -163,7 +163,7 @@ check_connection() {
set -e
}
-parse_yaml() {
+function parse_yaml {
local prefix=$2
local s
local w
@@ -183,3 +183,16 @@ parse_yaml() {
}
}' | sed 's/_=/+=/g'
}
+
+function wait_for {
+ local total_attempts=$1; shift
+ local cmdstr=$*
+ local sleep_time=10
+ echo "[NOTE] Waiting for cmd to return success: ${cmdstr}"
+ # shellcheck disable=SC2034
+ for attempt in $(seq "${total_attempts}"); do
+ # shellcheck disable=SC2015
+ eval "${cmdstr}" && break || true
+ echo -n '.'; sleep "${sleep_time}"
+ done
+}